###################################################################################################
# zmstrashcan.py
#
# Implementation of classes ZMSTrashcan (see below).
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###################################################################################################

# Imports.
from Globals import HTML, HTMLFile
import copy
import string
import time
import urllib
# Product Imports.
from zmscontainerobject import ZMSContainerObject


###################################################################################################
###################################################################################################
###
###   class ZMSTrashcan
###
###################################################################################################
###################################################################################################
class ZMSTrashcan(ZMSContainerObject):

    # Properties.
    # -----------
    meta_type = "ZMSTrashcan"
    icon = "misc_/zms/zmstrashcan.gif"
    icon_disabled = "misc_/zms/zmstrashcan_disabled.gif"
    
    # Management Options.
    # -------------------
    manage_options = ( 
	{'label': 'TYPE_ZMSTRASHCAN', 'action': 'manage_main'},
	) 

    # Management Permissions.
    # -----------------------
    __authorPermissions__ = (
		'manage','manage_main',
		'manage_deleteObjs','manage_moveObjUp','manage_moveObjDown','manage_cutObjects',
		)
    __editorPermissions__ = (
		'manage_commitVersionChanges',
		)
    __administratorPermissions__ = (
		)
    __ac_permissions__=(
		('ZMS Author', __authorPermissions__),
		('ZMS Editor', __editorPermissions__),
		('ZMS Administrator', __administratorPermissions__),
		)

    # Properties.
    # -----------
    __obj_attrs__ = {}

    # ---------------------------------------------------------------------------------------------
    #  ZMSTrashcan.isActive
    # ---------------------------------------------------------------------------------------------
    def isActive(self, REQUEST): return len(self.getChildNodes(REQUEST))>0

    # ---------------------------------------------------------------------------------------------
    #  ZMSTrashcan.getTitle
    # ---------------------------------------------------------------------------------------------
    def getTitle(self, REQUEST): return self.display_type(REQUEST) + " (" + str(len(self.getChildNodes(REQUEST))) + " " + self.getLangStr('ATTR_OBJECTS',REQUEST['lang']) + ")"

    # ---------------------------------------------------------------------------------------------
    #  ZMSTrashcan.getTitlealt
    # ---------------------------------------------------------------------------------------------
    def getTitlealt(self, REQUEST): return self.display_type(REQUEST)

    ###############################################################################################
    #  ZMSTrashcan.manage_deleteObjs:
    #
    #  Delete a subordinate object:
    #  The objects specified in 'ids' get deleted.
    ###############################################################################################
    def manage_deleteObjs(self, lang, manage_lang, ids, REQUEST, RESPONSE=None):
      """ ZMSTrashcan.manage_deleteObjs """ 
      
      message = ''
      
      ##### Delete objects ####
      count = len(ids)
      self.manage_delObjects(ids=ids)
      
      # Return with message.
      if RESPONSE is not None:
        message = self.getLangStr('MSG_DELETED',manage_lang)%count
        return RESPONSE.redirect('manage_main?lang=%s&manage_lang=%s&manage_tabs_message=%s'%(lang,manage_lang,urllib.quote(message)))

###################################################################################################
